diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-point-device.h ns-3.40/src/mesh/model/mesh-point-device.h
--- ns-3.39/src/mesh/model/mesh-point-device.h	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-point-device.h	2023-09-27 13:30:37.834839600 -0700
@@ -21,9 +21,10 @@
 #ifndef L2ROUTING_NET_DEVICE_H
 #define L2ROUTING_NET_DEVICE_H
 
+#include "mesh-l2-routing-protocol.h"
+
 #include "ns3/bridge-channel.h"
 #include "ns3/mac48-address.h"
-#include "ns3/mesh-l2-routing-protocol.h"
 #include "ns3/net-device.h"
 #include "ns3/node.h"
 #include "ns3/random-variable-stream.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-wifi-beacon.cc ns-3.40/src/mesh/model/mesh-wifi-beacon.cc
--- ns-3.39/src/mesh/model/mesh-wifi-beacon.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-wifi-beacon.cc	2023-09-27 13:30:37.834839600 -0700
@@ -17,7 +17,7 @@
  * Author: Pavel Boyko <boyko@iitp.ru>
  */
 
-#include "ns3/mesh-wifi-beacon.h"
+#include "mesh-wifi-beacon.h"
 
 #include "ns3/nstime.h"
 #include "ns3/wifi-mac-header.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-wifi-beacon.h ns-3.40/src/mesh/model/mesh-wifi-beacon.h
--- ns-3.39/src/mesh/model/mesh-wifi-beacon.h	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-wifi-beacon.h	2023-09-27 13:30:37.834839600 -0700
@@ -20,7 +20,8 @@
 #ifndef MESH_WIFI_BEACON_H
 #define MESH_WIFI_BEACON_H
 
-#include "ns3/mesh-information-element-vector.h"
+#include "mesh-information-element-vector.h"
+
 #include "ns3/mgt-headers.h"
 #include "ns3/object.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-wifi-interface-mac.cc ns-3.40/src/mesh/model/mesh-wifi-interface-mac.cc
--- ns-3.39/src/mesh/model/mesh-wifi-interface-mac.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-wifi-interface-mac.cc	2023-09-27 13:30:37.834839600 -0700
@@ -18,14 +18,15 @@
  *          Pavel Boyko <boyko@iitp.ru>
  */
 
-#include "ns3/mesh-wifi-interface-mac.h"
+#include "mesh-wifi-interface-mac.h"
+
+#include "mesh-wifi-beacon.h"
 
 #include "ns3/boolean.h"
 #include "ns3/channel-access-manager.h"
 #include "ns3/double.h"
 #include "ns3/log.h"
 #include "ns3/mac-tx-middle.h"
-#include "ns3/mesh-wifi-beacon.h"
 #include "ns3/pointer.h"
 #include "ns3/qos-txop.h"
 #include "ns3/random-variable-stream.h"
@@ -166,7 +167,7 @@
     NS_LOG_FUNCTION(this << stream);
     int64_t currentStream = stream;
     m_coefficient->SetStream(currentStream++);
-    for (PluginList::const_iterator i = m_plugins.begin(); i < m_plugins.end(); i++)
+    for (auto i = m_plugins.begin(); i < m_plugins.end(); i++)
     {
         currentStream += (*i)->AssignStreams(currentStream);
     }
@@ -239,7 +240,7 @@
     // Address 1 is unknown here. Routing plugin is responsible to correctly set it.
     hdr.SetAddr1(Mac48Address());
     // Filter packet through all installed plugins
-    for (PluginList::const_iterator i = m_plugins.end() - 1; i != m_plugins.begin() - 1; i--)
+    for (auto i = m_plugins.end() - 1; i != m_plugins.begin() - 1; i--)
     {
         bool drop = !((*i)->UpdateOutcomingFrame(packet, hdr, from, to));
         if (drop)
@@ -285,7 +286,7 @@
 {
     // Filter management frames:
     WifiMacHeader header = hdr;
-    for (PluginList::const_iterator i = m_plugins.end() - 1; i != m_plugins.begin() - 1; i--)
+    for (auto i = m_plugins.end() - 1; i != m_plugins.begin() - 1; i--)
     {
         bool drop = !((*i)->UpdateOutcomingFrame(packet, header, Mac48Address(), Mac48Address()));
         if (drop)
@@ -428,7 +429,7 @@
     MeshWifiBeacon beacon(GetSsid(), GetSupportedRates(), m_beaconInterval.GetMicroSeconds());
 
     // Ask all plugins to add their specific information elements to beacon
-    for (PluginList::const_iterator i = m_plugins.begin(); i != m_plugins.end(); ++i)
+    for (auto i = m_plugins.begin(); i != m_plugins.end(); ++i)
     {
         (*i)->UpdateBeacon(beacon);
     }
@@ -486,7 +487,7 @@
         m_stats.recvFrames++;
     }
     // Filter frame through all installed plugins
-    for (PluginList::iterator i = m_plugins.begin(); i != m_plugins.end(); ++i)
+    for (auto i = m_plugins.begin(); i != m_plugins.end(); ++i)
     {
         bool drop = !((*i)->Receive(packet, *hdr));
         if (drop)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-wifi-interface-mac.h ns-3.40/src/mesh/model/mesh-wifi-interface-mac.h
--- ns-3.39/src/mesh/model/mesh-wifi-interface-mac.h	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-wifi-interface-mac.h	2023-09-27 13:30:37.834839600 -0700
@@ -21,10 +21,11 @@
 #ifndef MESH_WIFI_INTERFACE_MAC_H
 #define MESH_WIFI_INTERFACE_MAC_H
 
+#include "mesh-wifi-interface-mac-plugin.h"
+
 #include "ns3/callback.h"
 #include "ns3/event-id.h"
 #include "ns3/mac48-address.h"
-#include "ns3/mesh-wifi-interface-mac-plugin.h"
 #include "ns3/mgt-headers.h"
 #include "ns3/nstime.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-wifi-interface-mac-plugin.h ns-3.40/src/mesh/model/mesh-wifi-interface-mac-plugin.h
--- ns-3.39/src/mesh/model/mesh-wifi-interface-mac-plugin.h	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-wifi-interface-mac-plugin.h	2023-09-27 13:30:37.834839600 -0700
@@ -20,8 +20,9 @@
 #ifndef MESH_WIFI_INTERFACE_MAC_PLUGIN_H
 #define MESH_WIFI_INTERFACE_MAC_PLUGIN_H
 
+#include "mesh-wifi-beacon.h"
+
 #include "ns3/mac48-address.h"
-#include "ns3/mesh-wifi-beacon.h"
 #include "ns3/packet.h"
 #include "ns3/simple-ref-count.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/test/dot11s/dot11s-test-suite.cc ns-3.40/src/mesh/test/dot11s/dot11s-test-suite.cc
--- ns-3.39/src/mesh/test/dot11s/dot11s-test-suite.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/test/dot11s/dot11s-test-suite.cc	2023-09-27 13:30:37.834839600 -0700
@@ -186,8 +186,7 @@
 void
 HwmpRtableTest::TestPrecursorAdd()
 {
-    for (std::vector<Mac48Address>::const_iterator i = precursors.begin(); i != precursors.end();
-         i++)
+    for (auto i = precursors.begin(); i != precursors.end(); i++)
     {
         table->AddPrecursor(dst, iface, *i, Seconds(100));
         // Check that duplicates are filtered
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/CMakeLists.txt ns-3.40/src/mobility/CMakeLists.txt
--- ns-3.39/src/mobility/CMakeLists.txt	2023-07-05 14:23:48.041428000 -0700
+++ ns-3.40/src/mobility/CMakeLists.txt	2023-09-27 13:30:37.838839500 -0700
@@ -50,6 +50,7 @@
     test/mobility-trace-test-suite.cc
     test/ns2-mobility-helper-test-suite.cc
     test/rand-cart-around-geo-test.cc
+    test/rectangle-closest-border-test.cc
     test/steady-state-random-waypoint-mobility-model-test.cc
     test/waypoint-mobility-model-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/examples/main-grid-topology.cc ns-3.40/src/mobility/examples/main-grid-topology.cc
--- ns-3.39/src/mobility/examples/main-grid-topology.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/examples/main-grid-topology.cc	2023-09-27 13:30:37.838839500 -0700
@@ -61,7 +61,7 @@
     mobility.Install(nodes);
 
     // iterate our nodes and print their position.
-    for (NodeContainer::Iterator j = nodes.Begin(); j != nodes.End(); ++j)
+    for (auto j = nodes.Begin(); j != nodes.End(); ++j)
     {
         Ptr<Node> object = *j;
         Ptr<MobilityModel> position = object->GetObject<MobilityModel>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/helper/group-mobility-helper.cc ns-3.40/src/mobility/helper/group-mobility-helper.cc
--- ns-3.39/src/mobility/helper/group-mobility-helper.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/helper/group-mobility-helper.cc	2023-09-27 13:30:37.838839500 -0700
@@ -19,7 +19,7 @@
  * Adapted from 'mobility-helper.cc' for group mobility by Tom Henderson
  */
 
-#include "ns3/group-mobility-helper.h"
+#include "group-mobility-helper.h"
 
 #include "ns3/config.h"
 #include "ns3/hierarchical-mobility-model.h"
@@ -101,7 +101,7 @@
 void
 GroupMobilityHelper::Install(NodeContainer c)
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Install(*i);
     }
@@ -114,7 +114,7 @@
     Ptr<Node> node;
     bool firstNode = true;
     Ptr<HierarchicalMobilityModel> mobility;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         node = (*i);
         mobility = node->GetObject<HierarchicalMobilityModel>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/helper/mobility-helper.cc ns-3.40/src/mobility/helper/mobility-helper.cc
--- ns-3.39/src/mobility/helper/mobility-helper.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/helper/mobility-helper.cc	2023-09-27 13:30:37.838839500 -0700
@@ -16,7 +16,7 @@
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
-#include "ns3/mobility-helper.h"
+#include "mobility-helper.h"
 
 #include "ns3/config.h"
 #include "ns3/hierarchical-mobility-model.h"
@@ -126,7 +126,7 @@
 void
 MobilityHelper::Install(NodeContainer c) const
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Install(*i);
     }
@@ -201,7 +201,7 @@
 void
 MobilityHelper::EnableAscii(Ptr<OutputStreamWrapper> stream, NodeContainer n)
 {
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         EnableAscii(stream, (*i)->GetId());
     }
@@ -219,7 +219,7 @@
     int64_t currentStream = stream;
     Ptr<Node> node;
     Ptr<MobilityModel> mobility;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         node = (*i);
         mobility = node->GetObject<MobilityModel>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/helper/ns2-mobility-helper.cc ns-3.40/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.39/src/mobility/helper/ns2-mobility-helper.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/helper/ns2-mobility-helper.cc	2023-09-27 13:30:37.838839500 -0700
@@ -523,7 +523,7 @@
     {
         std::string x;
         s >> x;
-        if (x.length() == 0)
+        if (x.empty())
         {
             continue;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/constant-velocity-helper.cc ns-3.40/src/mobility/model/constant-velocity-helper.cc
--- ns-3.39/src/mobility/model/constant-velocity-helper.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/constant-velocity-helper.cc	2023-09-27 13:30:37.838839500 -0700
@@ -18,9 +18,10 @@
  */
 #include "constant-velocity-helper.h"
 
-#include "ns3/box.h"
+#include "box.h"
+#include "rectangle.h"
+
 #include "ns3/log.h"
-#include "ns3/rectangle.h"
 #include "ns3/simulator.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/constant-velocity-helper.h ns-3.40/src/mobility/model/constant-velocity-helper.h
--- ns-3.39/src/mobility/model/constant-velocity-helper.h	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/constant-velocity-helper.h	2023-09-27 13:30:37.838839500 -0700
@@ -19,7 +19,8 @@
 #ifndef CONSTANT_VELOCITY_HELPER_H
 #define CONSTANT_VELOCITY_HELPER_H
 
-#include "ns3/box.h"
+#include "box.h"
+
 #include "ns3/nstime.h"
 #include "ns3/vector.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/gauss-markov-mobility-model.h ns-3.40/src/mobility/model/gauss-markov-mobility-model.h
--- ns-3.39/src/mobility/model/gauss-markov-mobility-model.h	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/gauss-markov-mobility-model.h	2023-09-27 13:30:37.838839500 -0700
@@ -21,11 +21,11 @@
 #ifndef GAUSS_MARKOV_MOBILITY_MODEL_H
 #define GAUSS_MARKOV_MOBILITY_MODEL_H
 
+#include "box.h"
 #include "constant-velocity-helper.h"
 #include "mobility-model.h"
 #include "position-allocator.h"
 
-#include "ns3/box.h"
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/random-direction-2d-mobility-model.cc ns-3.40/src/mobility/model/random-direction-2d-mobility-model.cc
--- ns-3.39/src/mobility/model/random-direction-2d-mobility-model.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/random-direction-2d-mobility-model.cc	2023-09-27 13:30:37.842839700 -0700
@@ -117,23 +117,36 @@
 void
 RandomDirection2dMobilityModel::ResetDirectionAndSpeed()
 {
-    double direction = m_direction->GetValue(0, M_PI);
+    double direction = 0;
 
     m_helper.UpdateWithBounds(m_bounds);
     Vector position = m_helper.GetCurrentPosition();
-    switch (m_bounds.GetClosestSide(position))
+    switch (m_bounds.GetClosestSideOrCorner(position))
     {
-    case Rectangle::RIGHT:
-        direction += M_PI / 2;
+    case Rectangle::RIGHTSIDE:
+        direction = m_direction->GetValue(M_PI_2, M_PI + M_PI_2);
+        break;
+    case Rectangle::LEFTSIDE:
+        direction = m_direction->GetValue(-M_PI_2, M_PI - M_PI_2);
+        break;
+    case Rectangle::TOPSIDE:
+        direction = m_direction->GetValue(M_PI, 2 * M_PI);
         break;
-    case Rectangle::LEFT:
-        direction += -M_PI / 2;
+    case Rectangle::BOTTOMSIDE:
+        direction = m_direction->GetValue(0, M_PI);
         break;
-    case Rectangle::TOP:
-        direction += M_PI;
+    case Rectangle::TOPRIGHTCORNER:
+        direction = m_direction->GetValue(M_PI, M_PI + M_PI_2);
+        break;
+    case Rectangle::TOPLEFTCORNER:
+        direction = m_direction->GetValue(M_PI + M_PI_2, 2 * M_PI);
+        break;
+    case Rectangle::BOTTOMRIGHTCORNER:
+        direction = m_direction->GetValue(0, M_PI_2);
+        direction += M_PI / 2;
         break;
-    case Rectangle::BOTTOM:
-        direction += 0.0;
+    case Rectangle::BOTTOMLEFTCORNER:
+        direction = m_direction->GetValue(M_PI_2, M_PI);
         break;
     }
     SetDirectionAndSpeed(direction);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/random-direction-2d-mobility-model.h ns-3.40/src/mobility/model/random-direction-2d-mobility-model.h
--- ns-3.39/src/mobility/model/random-direction-2d-mobility-model.h	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/random-direction-2d-mobility-model.h	2023-09-27 13:30:37.842839700 -0700
@@ -21,13 +21,13 @@
 
 #include "constant-velocity-helper.h"
 #include "mobility-model.h"
+#include "rectangle.h"
 
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/ptr.h"
 #include "ns3/random-variable-stream.h"
-#include "ns3/rectangle.h"
 
 namespace ns3
 {
@@ -40,7 +40,7 @@
  * pauses for a specific delay, chooses a random direction and speed and
  * then travels in the specific direction until it reaches one of
  * the boundaries of the model. When it reaches the boundary, it pauses,
- * selects a new direction and speed, aso.
+ * and selects a new direction and speed.
  */
 class RandomDirection2dMobilityModel : public MobilityModel
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/random-walk-2d-mobility-model.cc ns-3.40/src/mobility/model/random-walk-2d-mobility-model.cc
--- ns-3.39/src/mobility/model/random-walk-2d-mobility-model.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/random-walk-2d-mobility-model.cc	2023-09-27 13:30:37.842839700 -0700
@@ -90,8 +90,46 @@
 RandomWalk2dMobilityModel::DoInitializePrivate()
 {
     m_helper.Update();
+    Vector position = m_helper.GetCurrentPosition();
+
     double speed = m_speed->GetValue();
-    double direction = m_direction->GetValue();
+    double direction = 0;
+    if (!m_bounds.IsOnTheBorder(position))
+    {
+        direction = m_direction->GetValue();
+    }
+    else
+    {
+        Ptr<UniformRandomVariable> directionOverride = CreateObject<UniformRandomVariable>();
+        switch (m_bounds.GetClosestSideOrCorner(position))
+        {
+        case Rectangle::RIGHTSIDE:
+            direction = directionOverride->GetValue(M_PI_2, M_PI + M_PI_2);
+            break;
+        case Rectangle::LEFTSIDE:
+            direction = directionOverride->GetValue(-M_PI_2, M_PI - M_PI_2);
+            break;
+        case Rectangle::TOPSIDE:
+            direction = directionOverride->GetValue(M_PI, 2 * M_PI);
+            break;
+        case Rectangle::BOTTOMSIDE:
+            direction = directionOverride->GetValue(0, M_PI);
+            break;
+        case Rectangle::TOPRIGHTCORNER:
+            direction = directionOverride->GetValue(M_PI, M_PI + M_PI_2);
+            break;
+        case Rectangle::TOPLEFTCORNER:
+            direction = directionOverride->GetValue(M_PI + M_PI_2, 2 * M_PI);
+            break;
+        case Rectangle::BOTTOMRIGHTCORNER:
+            direction = directionOverride->GetValue(0, M_PI_2);
+            direction += M_PI / 2;
+            break;
+        case Rectangle::BOTTOMLEFTCORNER:
+            direction = directionOverride->GetValue(M_PI_2, M_PI);
+            break;
+        }
+    }
     Vector vector(std::cos(direction) * speed, std::sin(direction) * speed, 0.0);
     m_helper.SetVelocity(vector);
     m_helper.Unpause();
@@ -125,7 +163,23 @@
     else
     {
         nextPosition = m_bounds.CalculateIntersection(position, speed);
-        Time delay = Seconds((nextPosition.x - position.x) / speed.x);
+        double delaySeconds = std::numeric_limits<double>::max();
+        if (speed.x != 0)
+        {
+            delaySeconds =
+                std::min(delaySeconds, std::abs((nextPosition.x - position.x) / speed.x));
+        }
+        else if (speed.y != 0)
+        {
+            delaySeconds =
+                std::min(delaySeconds, std::abs((nextPosition.y - position.y) / speed.y));
+        }
+        else
+        {
+            NS_ABORT_MSG("RandomWalk2dMobilityModel::DoWalk: unable to calculate the rebound time "
+                         "(the node is stationary).");
+        }
+        Time delay = Seconds(delaySeconds);
         m_event = Simulator::Schedule(delay,
                                       &RandomWalk2dMobilityModel::Rebound,
                                       this,
@@ -140,16 +194,24 @@
     m_helper.UpdateWithBounds(m_bounds);
     Vector position = m_helper.GetCurrentPosition();
     Vector speed = m_helper.GetVelocity();
-    switch (m_bounds.GetClosestSide(position))
+    switch (m_bounds.GetClosestSideOrCorner(position))
     {
-    case Rectangle::RIGHT:
-    case Rectangle::LEFT:
+    case Rectangle::RIGHTSIDE:
+    case Rectangle::LEFTSIDE:
         speed.x = -speed.x;
         break;
-    case Rectangle::TOP:
-    case Rectangle::BOTTOM:
+    case Rectangle::TOPSIDE:
+    case Rectangle::BOTTOMSIDE:
         speed.y = -speed.y;
         break;
+    case Rectangle::TOPRIGHTCORNER:
+    case Rectangle::BOTTOMRIGHTCORNER:
+    case Rectangle::TOPLEFTCORNER:
+    case Rectangle::BOTTOMLEFTCORNER:
+        auto temp = speed.x;
+        speed.x = -speed.y;
+        speed.y = -temp;
+        break;
     }
     m_helper.SetVelocity(speed);
     m_helper.Unpause();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/random-walk-2d-mobility-model.h ns-3.40/src/mobility/model/random-walk-2d-mobility-model.h
--- ns-3.39/src/mobility/model/random-walk-2d-mobility-model.h	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/random-walk-2d-mobility-model.h	2023-09-27 13:30:37.842839700 -0700
@@ -21,12 +21,12 @@
 
 #include "constant-velocity-helper.h"
 #include "mobility-model.h"
+#include "rectangle.h"
 
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/random-variable-stream.h"
-#include "ns3/rectangle.h"
 
 namespace ns3
 {
@@ -42,6 +42,11 @@
  * of the model, we rebound on the boundary with a reflexive angle
  * and speed. This model is often identified as a brownian motion
  * model.
+ *
+ * The Direction random variable is used for any point strictly
+ * inside the boundaries. The points on the boundary have their
+ * direction chosen randomly, without considering the Direction
+ * Attribute.
  */
 class RandomWalk2dMobilityModel : public MobilityModel
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/rectangle.cc ns-3.40/src/mobility/model/rectangle.cc
--- ns-3.39/src/mobility/model/rectangle.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/rectangle.cc	2023-09-27 13:30:37.842839700 -0700
@@ -23,6 +23,7 @@
 #include "ns3/vector.h"
 
 #include <algorithm>
+#include <array>
 #include <cmath>
 #include <sstream>
 
@@ -52,126 +53,99 @@
            position.y >= this->yMin;
 }
 
+bool
+Rectangle::IsOnTheBorder(const Vector& position) const
+{
+    return position.x == this->xMax || position.x == this->xMin || position.y == this->yMax ||
+           position.y == this->yMin;
+}
+
 Rectangle::Side
-Rectangle::GetClosestSide(const Vector& position) const
+Rectangle::GetClosestSideOrCorner(const Vector& position) const
 {
-    if (IsInside(position))
+    std::array<double, 4> distanceFromBorders{
+        std::abs(position.x - this->xMin), // left border
+        std::abs(this->xMax - position.x), // right border
+        std::abs(position.y - this->yMin), // bottom border
+        std::abs(this->yMax - position.y), // top border
+    };
+    uint8_t flags = 0;
+    double minDist = std::numeric_limits<double>::max();
+    for (int i = 0; i < 4; i++)
     {
-        double xMinDist = std::abs(position.x - this->xMin);
-        double xMaxDist = std::abs(this->xMax - position.x);
-        double yMinDist = std::abs(position.y - this->yMin);
-        double yMaxDist = std::abs(this->yMax - position.y);
-        double minX = std::min(xMinDist, xMaxDist);
-        double minY = std::min(yMinDist, yMaxDist);
-        if (minX < minY)
+        if (distanceFromBorders[i] > minDist)
         {
-            if (xMinDist < xMaxDist)
-            {
-                return LEFT;
-            }
-            else
-            {
-                return RIGHT;
-            }
+            continue;
         }
-        else
+        // In case we find a border closer to the position,
+        // we replace it and mark the flag
+        if (distanceFromBorders[i] < minDist)
         {
-            if (yMinDist < yMaxDist)
-            {
-                return BOTTOM;
-            }
-            else
-            {
-                return TOP;
-            }
+            minDist = distanceFromBorders[i];
+            flags = 0;
         }
+        flags |= (0b1000 >> i);
     }
-    else
-    {
-        if (position.x < this->xMin)
+    NS_ASSERT(minDist != std::numeric_limits<double>::max());
+    Rectangle::Side side;
+    switch (flags)
+    {
+    //     LRBT
+    case 0b1111:
+        // Every side is equally distant, so choose any
+        side = TOPSIDE;
+        break;
+    case 0b0011:
+        // Opposing sides are equally distant, so we need to check the other two
+        // We also need to check if we're inside or outside.
+        side = TOPSIDE;
+        if (!IsInside(position))
         {
-            if (position.y < this->yMin)
-            {
-                double yDiff = this->yMin - position.y;
-                double xDiff = this->xMin - position.x;
-                if (yDiff > xDiff)
-                {
-                    return BOTTOM;
-                }
-                else
-                {
-                    return LEFT;
-                }
-            }
-            else if (position.y < this->yMax)
-            {
-                return LEFT;
-            }
-            else
-            {
-                double yDiff = position.y - this->yMax;
-                double xDiff = this->xMin - position.x;
-                if (yDiff > xDiff)
-                {
-                    return TOP;
-                }
-                else
-                {
-                    return LEFT;
-                }
-            }
+            side = (distanceFromBorders[0] > distanceFromBorders[1]) ? RIGHTSIDE : LEFTSIDE;
         }
-        else if (position.x < this->xMax)
+        break;
+    case 0b1100:
+        // Opposing sides are equally distant, so we need to check the other two
+        // We also need to check if we're inside or outside.
+        side = RIGHTSIDE;
+        if (!IsInside(position))
         {
-            if (position.y < this->yMin)
-            {
-                return BOTTOM;
-            }
-            else if (position.y < this->yMax)
-            {
-                NS_FATAL_ERROR(
-                    "This region should have been reached if the IsInside check was true");
-                return TOP; // silence compiler warning
-            }
-            else
-            {
-                return TOP;
-            }
-        }
-        else
-        {
-            if (position.y < this->yMin)
-            {
-                double yDiff = this->yMin - position.y;
-                double xDiff = position.x - this->xMin;
-                if (yDiff > xDiff)
-                {
-                    return BOTTOM;
-                }
-                else
-                {
-                    return RIGHT;
-                }
-            }
-            else if (position.y < this->yMax)
-            {
-                return RIGHT;
-            }
-            else
-            {
-                double yDiff = position.y - this->yMax;
-                double xDiff = position.x - this->xMin;
-                if (yDiff > xDiff)
-                {
-                    return TOP;
-                }
-                else
-                {
-                    return RIGHT;
-                }
-            }
+            side = (distanceFromBorders[2] > distanceFromBorders[3]) ? TOPSIDE : BOTTOMSIDE;
         }
+        break;
+    case 0b0001:
+    case 0b1101:
+        side = TOPSIDE;
+        break;
+    case 0b0010:
+    case 0b1110:
+        side = BOTTOMSIDE;
+        break;
+    case 0b0100:
+    case 0b0111:
+        side = RIGHTSIDE;
+        break;
+    case 0b0101:
+        side = TOPRIGHTCORNER;
+        break;
+    case 0b0110:
+        side = BOTTOMRIGHTCORNER;
+        break;
+    case 0b1000:
+    case 0b1011:
+        side = LEFTSIDE;
+        break;
+    case 0b1001:
+        side = TOPLEFTCORNER;
+        break;
+    case 0b1010:
+        side = BOTTOMLEFTCORNER;
+        break;
+    default:
+        NS_FATAL_ERROR("Impossible case");
+        break;
     }
+    return side;
 }
 
 Vector
@@ -247,4 +221,44 @@
     return is;
 }
 
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param side the rectangle side
+ * \returns a reference to the stream
+ */
+std::ostream&
+operator<<(std::ostream& os, const Rectangle::Side& side)
+{
+    switch (side)
+    {
+    case Rectangle::RIGHTSIDE:
+        os << "RIGHTSIDE";
+        break;
+    case Rectangle::LEFTSIDE:
+        os << "LEFTSIDE";
+        break;
+    case Rectangle::TOPSIDE:
+        os << "TOPSIDE";
+        break;
+    case Rectangle::BOTTOMSIDE:
+        os << "BOTTOMSIDE";
+        break;
+    case Rectangle::TOPRIGHTCORNER:
+        os << "TOPRIGHTCORNER";
+        break;
+    case Rectangle::TOPLEFTCORNER:
+        os << "TOPLEFTCORNER";
+        break;
+    case Rectangle::BOTTOMRIGHTCORNER:
+        os << "BOTTOMRIGHTCORNER";
+        break;
+    case Rectangle::BOTTOMLEFTCORNER:
+        os << "BOTTOMLEFTCORNER";
+        break;
+    }
+    return os;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/model/rectangle.h ns-3.40/src/mobility/model/rectangle.h
--- ns-3.39/src/mobility/model/rectangle.h	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/model/rectangle.h	2023-09-27 13:30:37.842839700 -0700
@@ -39,10 +39,14 @@
      */
     enum Side
     {
-        RIGHT,
-        LEFT,
-        TOP,
-        BOTTOM
+        RIGHTSIDE = 0,
+        LEFTSIDE,
+        TOPSIDE,
+        BOTTOMSIDE,
+        TOPRIGHTCORNER,
+        TOPLEFTCORNER,
+        BOTTOMRIGHTCORNER,
+        BOTTOMLEFTCORNER
     };
 
     /**
@@ -68,12 +72,34 @@
     bool IsInside(const Vector& position) const;
     /**
      * \param position the position to test.
+     * \return true if the input position is located on the rectable border, false otherwise.
+     *
+     * This method compares only the x and y coordinates of the input position.
+     * It ignores the z coordinate.
+     */
+    bool IsOnTheBorder(const Vector& position) const;
+    /**
+     * \param position the position to test.
      * \return the side of the rectangle the input position is closest to.
      *
      * This method compares only the x and y coordinates of the input position.
      * It ignores the z coordinate.
+     *
+     * This method assumes assumes a right-handed Cartesian orientation, so that
+     * (xMin, yMin) is the BOTTOMLEFTCORNER,  the TOP and BOTTOM sides are parallel to
+     * the x-axis, the LEFT and RIGHT sides are parallel to the y-axis, and the
+     * (xMax, yMax) point is the TOPRIGHTCORNER.
+     *
+     * Beware: the method has an ambiguity in the "center" of the rectangle. Assume
+     * a rectangle between the points (0, 0) and (4, 2), i.e., wider than taller.
+     * All the points on the line between (1, 1) and (3, 1) are equally closer to the
+     * TOP and BOTTOM than to the other sides of the Rectangle.
+     * These points are classified as TOPSIDE by convention.
+     *
+     * Similarly, for a Rectangle taller than wider, the "center" points will be
+     * classified as RIGHTSIDE, and for a square box, the center will return RIGHTSIDE.
      */
-    Side GetClosestSide(const Vector& position) const;
+    Side GetClosestSideOrCorner(const Vector& position) const;
     /**
      * \param current the current position
      * \param speed the current speed
@@ -94,6 +120,7 @@
 
 std::ostream& operator<<(std::ostream& os, const Rectangle& rectangle);
 std::istream& operator>>(std::istream& is, Rectangle& rectangle);
+std::ostream& operator<<(std::ostream& os, const Rectangle::Side& side);
 
 ATTRIBUTE_HELPER_HEADER(Rectangle);
 
